"use strict";

module.exports = function (app, payListen, auth) {
  return app.get('/payment-stream', auth, function (req, res) {
    res.set({
      'X-Accel-Buffering': 'no',
      'Cache-Control': 'no-cache',
      'Content-Type': 'text/event-stream',
      'Connection': 'keep-alive'
    }).flushHeaders();

    var onPay = function onPay(inv) {
      return res.write("id:".concat(inv.pay_index, "\ndata:").concat(JSON.stringify(inv), "\n\n"));
    };

    payListen.on('payment', onPay);
    var keepAlive = setInterval(function (_) {
      return res.write(': keepalive\n\n');
    }, 25000);
    req.on('close', function (_) {
      return payListen.removeListener('payment', onPay), clearInterval(keepAlive);
    });
  });
};